//
//  MainView.h
//  beamermath

/*
 Created on 9.8.2018 by
 
 PD Dr. Fritz Hörmann
 Mathematisches Institut - Raum 433
 Albert-Ludwigs-Universität Freiburg
 Ernst-Zermelo-Strasse 1
 D-79104 Freiburg
 eMail: fritz.hoermann@math.uni-freiburg.de
 Tel: +49 761 99520388
 
 Licensed under CC BY-SA 4.0.
 https://creativecommons.org/licenses/by-sa/4.0/legalcode
 */

#import <Cocoa/Cocoa.h>

@interface MBCmd : NSObject

@property    NSString* cmd;
@property    NSMutableArray* params;

@end

@interface MBBox : NSObject

@property    int ipdfpage;
@property    CGRect rect;

@end

@interface MBPage : NSObject

@property    int ipdfpage;
@property    NSMutableArray* commands;

@end


typedef struct _VALUE
{
    OSSpinLock lock;
    
    double v;
    double dv;
    double time; // A
    double stoptime;
} VALUE;


@interface MainView : NSOpenGLView
{
    NSTimeInterval frametime;
    CVDisplayLinkRef displayLink;
    CGAffineTransform transform;
    
    GLhandleARB proghyperbolic, proglseries;
    CGRect mouserect;
    
    VALUE anglex, angley, anglez, zoom, vec[3], basisx, basisy;
    double offset;
    
    bool goalscompleted;
    
    bool displaymouse;
    
    int ipage;
    int npage;
    NSString* pdftitle;
    
    GLuint pdftexture;
    GLuint windowtexture;
    GLuint lseriestexture;
    
    GLfloat* lseries;
    int wlseries;
    int hlseries;
}

- (void)pdfreadmetadata;
- (void)pdfloadpage;

@property NSMutableDictionary* boxes;
@property NSMutableDictionary* pages;
@property NSURL* url;

@end
