#version 110

// lseries.glsl
// beamermath

/*
 Created on 9.8.2018 by
 
 PD Dr. Fritz Hörmann
 Mathematisches Institut - Raum 433
 Albert-Ludwigs-Universität Freiburg
 Ernst-Zermelo-Strasse 1
 D-79104 Freiburg
 eMail: fritz.hoermann@math.uni-freiburg.de
 Tel: +49 761 99520388
 
 Licensed under CC BY-SA 4.0.
 https://creativecommons.org/licenses/by-sa/4.0/legalcode
 */


/* CHANNEL_ITER CHANNEL_X CHANNEL_Y */

#define M_PI 3.1415926535897932384626433832795

uniform sampler2D lseries;
uniform int mode;

vec4 hsv(float V, float S, float H)
{
    float C = V*S;
    float X = C*(1.0-abs(fract(H/120.0)*2.0-1.0));
    float m = V-C;
    vec3 c;
    if(H<=60.0)c = vec3(C,X,0.0);
    else if(H<=120.0)c = vec3(X,C,0.0);
    else if(H<=180.0)c = vec3(0.0,C,X);
    else if(H<=240.0)c = vec3(0.0,X,C);
    else if(H<=300.0)c = vec3(X,0.0,C);
    else c = vec3(C,0.0,X);
    return vec4(c.r+m,c.g+m,c.b+m,1.0);
}


void main()
{
    if(mode==0)
    {
        vec2 v = texture2D(lseries, gl_TexCoord[0].xy).xy;
        
        float l = (log(v.x*v.x + v.y*v.y)-1.0)*0.1;
        //    if(!cut||xd>2.0)
        
        gl_FragColor = hsv(l>0.0?1.0:max(1.0+l,0.2), l>0.0?max(1.0-l,0.2):1.0, atan(v.y, v.x)/M_PI*180.0+180.0);
    } else if(mode==1)
    {
        float x = gl_TexCoord[0].x*12.0-6.0;

        vec2 v = texture2D(lseries, gl_TexCoord[0].xy).xy;
        
        float l = (log(v.x*v.x + v.y*v.y)-1.0)*0.1;
        //    if(!cut||xd>2.0)
        
        if(x>=2.0)
            gl_FragColor = hsv(l>0.0?1.0:max(1.0+l,0.2), l>0.0?max(1.0-l,0.2):1.0, atan(v.y, v.x)/M_PI*180.0+180.0);
        else
            gl_FragColor = vec4(0.0,0.0,0.0,1.0);
    }
    else if(mode==2)
    {
        vec2 v;
        v.x = gl_TexCoord[0].x*12.0-6.0;
        v.y = gl_TexCoord[0].y*12.0-6.0;
        
        float l = (log(v.x*v.x + v.y*v.y)-1.0)*0.1;
        
        gl_FragColor = hsv(l>0.0?1.0:max(1.0+l,0.2), l>0.0?max(1.0-l,0.2):1.0, atan(v.y, v.x)/M_PI*180.0+180.0);
    }
//    gl_FragColor = hsv(l>0.0?max(1.0-l,0.2):1.0, l>0.0?1.0:max(1.0+l,0.2), atan(v.x, v.y)/M_PI*180.0+180.0);
//    gl_FragColor = hsv(1.0, 1.0, gl_TexCoord[0].x/M_PI*180.0+180.0);
//    gl_FragColor = hsv(1.0, 1.0, atan(v.y, v.x)/M_PI*180.0+180.0);
  //  gl_FragColor = vec4((v.x-v.y)+0.5,0.0,0.0,1.0);
//    gl_FragColor = vec4(atan(v.y, v.x)/M_PI,0,0,1.0);
}